# Python 3 library and CLI for [SporeStack](https://sporestack.com) [.onion](http://spore64i5sofqlfz5gq2ju4msgzojjwifls7rok2cti624zyq3fcelad.onion)

## Requirements

 * Python 3.7+

## Installation

 * `python3 -m pip install sporestack`
 * Recommended: Create a virtual environment, first. Can use `pipenv`, as well.

## Running without installing (preferred)

 * Make sure `pipx` is installed.
 * `pipx run sporestack`
 * Make sure you're on the latest version with `sporestack version`.

## Upgrade notes for going from v1.4 to v2

 * `sporestackv2` was renamed to `sporestack`.
 * CLI options with `_` have been changed to `-`. So `sporestackv2 settlement_token_balance` is not `sporestack settlement-token-balance. `--settlement_token` is now `--settlement-token`.
 * `sporestack launch` cores/memory/disk removed entirely in favor of flavor.
 * Package is now following [semver](https://semver.org).
 * Torified instance support has been removed.
 * `sporestack launch`'s `--ssh_key_file` has been replaced with `--ssh-key`.
 * WalkingLiberty support was removed. Best to use settlement tokens instead.

## Upgrade notes for going from v2 to v3

### Library

 * sporestack.__version__ was removed.
 * Now using SporeStackError exceptions with API requests.
 * validate, flavors removed (unneeded here)
 * Settlement token functions have new names, signatures, and responses.
 * Pydantic is now used for settlement token endpoints. (More to come)

### CLI

 * flavors command removed (for now)

## Screenshot

![sporestack CLI screenshot](https://sporestack.com/static/sporestackv2-screenshot.png)

## Usage

* `sporestack launch SomeHostname --flavor vps-1vcpu-1gb --days 7 --ssh-key ~/.ssh/id_rsa.pub --operating-system debian-9 --currency btc`
* `sporestack topup SomeHostname --days 3 --currency xmr`
* `sporestack launch SomeOtherHostname --flavor vps-1vcpu-2gb --days 7 --ssh-key ~/.ssh/id_rsa.pub --operating-system debian-10 --currency btc`
* `sporestack stop SomeHostname`
* `sporestack start SomeHostname`
* `sporestack list`
* `sporestack remove SomeHostname # If expired`
* `sporestack settlement-token-generate`
* `sporestack settlement-token-enable (token) --dollars 10 --currency xmr`
* `sporestack settlement-token-add (token) --dollars 25 --currency btc`
* `sporestack settlement-token-balance (token)`

More examples on the [website](https://sporestack.com).

## Notes

 * You can use `--settlement-token` if you don't want to pay with QR codes all the time.
 * If using a .onion API endpoint, will try to use a local Tor proxy if connecting to a .onion URL. (127.0.0.1:9050)

## Licence

[Unlicense/Public domain](LICENSE.txt)
